Unit IA83R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTIA10_p;

procedure IA83R(M :Integer; N :Integer; var X :Array of Real;
                var Y :Array of Real; var IN_ :Array of Integer;
                var ITER :Integer; var A :Array of Real;
                var AX :Array of Real; var JN :Array of Integer;
                var RAB :Array of Real; var IERR :Integer);

implementation

procedure IA83R(M :Integer; N :Integer; var X :Array of Real;
                var Y :Array of Real; var IN_ :Array of Integer;
                var ITER :Integer; var A :Array of Real;
                var AX :Array of Real; var JN :Array of Integer;
                var RAB :Array of Real; var IERR :Integer);
var
I,J,J1,J2,K,IZ,R1,R2,K1,K2,N1,N2,INDEX :Integer;
RHO,H,Z,W,RMAX,RMIN,RMAX1,RMIN1,U :Real;
D :Boolean;
const
ZERO :Real = 0.0;
label
_30,_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15,_16,_17,_18,
_19,_20,_21,_22,_23,_24,_25,_26,_27,_31,_28,_29;
begin
IERR := 0;
N1 := N+1;
ITER := 0;
N2 := N+2;
_30:
RHO := ZERO;
if ( N2-M ) < 0
 then goto _1
 else if ( N2-M ) > 0
       then goto _25
       else goto _1;
_1:
J := -1;
ITER := ITER+1;
J2 := IN_[0];
for I:=1 to N2 do
 begin
  J1 := J2;
  J2 := IN_[I-1];
  AX[I-1] := X[J2-1];
  RAB[0+(I-1)*2] := Y[J2-1];
  J := -J;
  RAB[1+(I-1)*2] := J;
  if ( I = 1 ) 
   then goto _2;
  if ( J1 >= J2 ) 
   then goto _26;
  if ( AX[I-1] <= AX[I-2] ) 
   then goto _27;
_2:
 end;
for K:=2 to N2 do
 begin
  for J:=K to N2 do
   begin
    I := N2-J+K;
    IZ := I-K+1;
    U := AX[I-1]-AX[IZ-1];
    RAB[0+(I-1)*2] := (RAB[0+(I-1)*2]-RAB[0+(I-1-1)*2])/U;
    RAB[1+(I-1)*2] := (RAB[1+(I-1)*2]-RAB[1+(I-1-1)*2])/U;
_3:
   end;
 end;
IZ := 1;
H := RAB[0+(N2-1)*2]/RAB[1+(N2-1)*2];
for I:=1 to N1 do
 begin
  A[I-1] := RAB[0+(I-1)*2]-H*RAB[1+(I-1)*2];
_4:
 end;
for J:=1 to N do
 begin
  I := N1-J;
  U := AX[I-1];
  for K:=I to N do
   begin
    A[K-1] := A[K-1]-A[K+0]*U;
_5:
   end;
 end;
U := RHO;
RHO := Abs(H);
if ( RHO > U ) 
 then goto _6;
RAB[0] := RHO;
goto _29;
_6:
if ( ITER = 30 ) 
 then goto _31;
IN_[0] := 1;
IN_[N2-1] := M;
D := True;
Z := ZERO;
RMAX1 := H/2.0;
RMIN1 := -RMAX1;
for I:=1 to N1 do
 begin
  RMIN := ZERO;
  RMAX := ZERO;
  J1 := IN_[I-1];
  R1 := J1;
  R2 := J1;
  J2 := IN_[I+0];
  for J:=J1 to J2 do
   begin
    W := ZERO;
    U := X[J-1];
    for K1:=1 to N1 do
     begin
      K := N1+1-K1;
      W := W*U+A[K-1];
_7:
     end;
    W := W-Y[J-1];
    if ( W-RMAX ) < 0
     then goto _9
     else if ( W-RMAX ) > 0
           then goto _8
           else goto _9;
_8:
    RMAX := W;
    R1 := J;
_9:
    if ( W-RMIN ) < 0
     then goto _10
     else if ( W-RMIN ) > 0
           then goto _11
           else goto _11;
_10:
    RMIN := W;
    R2 := J;
_11:
   end;
  if ( R1-R2 ) < 0
   then goto _13
   else if ( R1-R2 ) > 0
         then goto _12
         else goto _13;
_12:
  J := R1;
  R1 := R2;
  R2 := J;
  U := RMAX;
  RMAX := RMIN;
  RMIN := U;
_13:
  K1 := Trunc( Sign(1.0,RMIN1) );
  K2 := Trunc( Sign(1.0,RMAX) );
  if ( K1-K2 ) < 0
   then goto _18
   else if ( K1-K2 ) > 0
         then goto _18
         else goto _14;
_14:
  if ( Abs(RMIN1) >= Abs(RMAX) ) 
   then goto _15;
  JN[I-1] := R1;
  JN[I+0] := R2;
  RMAX1 := RMAX;
  RMIN1 := RMIN;
  if ( Abs(Z) > Abs(RMAX1) ) 
   then JN[I-2] := IZ;
  if ( not D ) 
   then goto _17;
  H := RMAX;
  D := False;
  goto _17;
_15:
  RMAX1 := RMIN1;
  if ( Abs(Z) <= Abs(RMIN) ) 
   then goto _16;
  JN[I+0] := IZ;
  RMIN1 := Z;
  goto _17;
_16:
  JN[I+0] := R2;
  RMIN1 := RMIN;
_17:
  Z := ZERO;
  goto _21;
_18:
  RMAX1 := RMIN1;
  if ( Abs(Z) <= Abs(RMAX) ) 
   then goto _19;
  JN[I+0] := IZ;
  RMIN1 := Z;
  goto _20;
_19:
  JN[I+0] := R1;
  RMIN1 := RMAX;
_20:
  IZ := R2;
  Z := RMIN;
_21:
 end;
if ( Abs(Z) <= Abs(H) ) 
 then goto _23;
for J:=1 to N1 do
 begin
  JN[J-1] := JN[J+0];
_22:
 end;
JN[N2-1] := IZ;
_23:
INDEX := 0;
for I:=1 to N2 do
 begin
  IN_[I-1] := JN[I-1];
  if ( IN_[I-1] >= IN_[I-2] ) or ( I = 1 ) 
   then goto _24;
  INDEX := IN_[I-1];
  IN_[I-1] := IN_[I-2];
  IN_[I-2] := INDEX;
_24:
 end;
if ( INDEX > 0 ) 
 then goto _30;
goto _1;
_25:
IERR := 65;
goto _28;
_26:
IERR := 66;
goto _28;
_27:
IERR := 67;
goto _28;
_31:
IERR := 68;
_28:
if ( IERR <> 0 ) 
 then UTIA10(IERR,83);
_29:
end;

end.
